#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

#include <config.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <Imlib.h>
#include "oscil.h"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

short *oscil_buf;
int oscil_bufsize;
int oscil_bufnum;
int oscil_fps = 37;
int oscil_lag = 10;
double o_scale_x = 1;
Window oscil_win;
int oscil_place = 0;
int oscil_w, oscil_h;
int oscil_num;
extern Display *disp;
extern GC fg, bg;

void oscil(void)
{
   int x, i;
   static int bnum;
   XPoint oscil_p[48];
   int origin;
   int num = oscil_bufsize / 48;
   int middle = oscil_h / 2;
   bnum = (((int)(oscil_num - oscil_lag) % oscil_bufnum) + oscil_bufnum) % oscil_bufnum;
   origin = bnum*oscil_bufsize*2;
   XClearWindow(disp, oscil_win);
   XFlush(disp);
   for (x = 0; x < 48; x++) {
      int val = 0;
      for (i = 0; i < num*2+1; i++)
         val += (int)oscil_buf[origin+(x*num*2)+i];
      val /= (13655*2);
      oscil_p[x].x = x*o_scale_x;
      oscil_p[x].y = middle + val;
   }
   XDrawLines(disp, oscil_win, fg, oscil_p, 48, CoordModeOrigin);
   XFlush(disp);
   oscil_num++;
   if (oscil_num >= oscil_bufnum)
      oscil_num = 0;
}

void do_analysis(char *buffer, int size)
{
   int temp, place; 
   temp = oscil_bufsize*4 - oscil_place;
   place = oscil_num*oscil_bufsize*2;
   if (size != oscil_bufsize*4) {
      if (temp == size) {
         memcpy(&oscil_buf[place]+oscil_place, buffer, size);
         oscil_place = 0;
         oscil();
         return;
      }
      if (size < temp) { 
         memcpy(&oscil_buf[place]+oscil_place, buffer, size);
	 oscil_place += size;
         return;
      }
      memcpy(&oscil_buf[place]+oscil_place, buffer, temp);
      oscil_place = 0;
      oscil();
      do_analysis(buffer+temp, size - temp);
      return;
   }
   memcpy(&oscil_buf[place]+oscil_place, buffer, size);
   oscil_place = 0;
   oscil();
}

int init_analysis(Window win, int w, int h)
{
   int size;
   int num;
   oscil_w = w;
   oscil_h = h;
   oscil_win = win;
   oscil_bufsize = size = ((44100/48)/oscil_fps)*48;
   o_scale_x = (double)oscil_w / 48.0;
   oscil_lag = (oscil_lag*1200)/size;
   num = oscil_lag + 2;
   oscil_bufnum = num;
   oscil_buf = (short*)calloc(size*num*4+40,sizeof(short));  
   oscil_num = 0;
   return oscil_bufsize*4;
}

void close_analysis(void)
{
   if (oscil_buf) 
      free(oscil_buf);  
   oscil_buf = NULL; 
}

void version_info(char *id, char *version, char *copyright)
{
   strcpy(id, "oscil, a hacked wayve");
   strcpy(version, "0.2");
   strcpy(copyright, "1996-1998 Carsten Haitzler");
}

