#include <X11/Xlib.h>

void synae(void);
void do_analysis(char *buffer, int size);
int init_analysis(Window win, int  w,int  h);
void close_analysis(void);
void version_info(char *id, char *version, char *copyright);

/* Synaesthesia - program to display sound graphically
   Copyright (C) 1997  Paul Francis Harrison

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  675 Mass Ave, Cambridge, MA 02139, USA.

  The author may be contacted at:
    phar6@student.monash.edu.au
  or
    27 Bond St., Mt. Waverley, 3149, Melbourne, Australia
*/

/***************************************/
/*   For the incurably fiddle prone:   */

/* log2 of sample size */
/* #define m 8  */

/* overlap amount between samples. Set to 1 or 2 if you have a fast computer */
#define overlap 0 

/* Brightness */
/* #define brightness 150 */

/* Sample frequency*/
/* #define frequency 22050 */

/***************************************/


void error(char *str);
#define attempt(x,y) if ((long int)(x) == -1) error(y)
void warning(char *str);
#define attemptNoDie(x,y) if ((long int)(x) == -1) warning(y)
/*
#define n (1<<m)
#define recSize (1<<m-overlap)
*/
/* core */
/* extern short *data; */
extern unsigned char *output;
extern int outWidth, outHeight;
extern int brightFactor;

void coreInit();
void coreGo();

void screenInit(Window win, int xHint,int yHint,int widthHint,int heightHint);
void screenEnd(void);
void screenShow(void);
void sizeRequest(int width,int height);
int sizeUpdate(void);
void mouseUpdate(void);
int mouseGetX(void);
int mouseGetY(void);
int mouseGetButtons(void);

int processUserInput(void); /* True == abort now */
void showOutput(void);

void error(char *str); /* Display error and exit */
void warning(char *str); /* Display error */
