#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

#include <config.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <Imlib.h>
#include "wayve.h"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

short *wayve_buf;
int wayve_bufsize;
int wayve_bufnum;
int wayve_fps = 37;
int wayve_lag = 0;
XPoint *wayve_p;
Window wayve_win;
int wayve_place = 0;
int wayve_w, wayve_h;
int wayve_num;
int data = FALSE;
extern Display *disp;
extern GC fg, bg;

void wayve(void)
{
   int x, i;
   static int bnum;
   int origin;
   int num = wayve_bufsize / wayve_w; 
   int middle = wayve_h / 2;
   int middle2 = wayve_w / 2;
   bnum = (((int)(wayve_num - wayve_lag) % wayve_bufnum) + wayve_bufnum) % wayve_bufnum;
   origin = bnum*wayve_bufsize*2;
   XClearWindow(disp, wayve_win);
   XFlush(disp); 
   for (x = 0; x < middle2; x++) {
      int val = 0;
      for (i = 0; i < num; i++)
         val += (int)wayve_buf[origin+(x*num*2)+(i<<1)];
      val /= 13655;
      wayve_p[(x<<1)+1].x = wayve_p[(x<<1)].x = x;
      wayve_p[(x<<1)].y = middle;
      wayve_p[(x<<1)+1].y = middle + val;
   }
   XDrawLines(disp, wayve_win, fg, wayve_p, wayve_w, CoordModeOrigin);
   for (x = 0; x < middle2; x++) {
      int val = 0;
      for (i = 0; i < num; i++)
         val += (int)wayve_buf[origin+(x*num*2)+(i<<1)+1];
      val /= 13655;
      wayve_p[(x<<1)+1].x = wayve_p[(x<<1)].x += middle2;
      wayve_p[(x<<1)+1].y = middle + val;
   }
   XDrawLines(disp, wayve_win, fg, wayve_p, wayve_w, CoordModeOrigin);
   XFlush(disp);
   wayve_num++;
   if (wayve_num >= wayve_bufnum)
      wayve_num = 0;
}

void do_analysis(char *buffer, int size)
{
   int temp, place; 
   temp = wayve_bufsize*4 - wayve_place;
   place = wayve_num*wayve_bufsize*2;
   if (size != wayve_bufsize*4) {
      if (temp == size) {
         memcpy(&wayve_buf[place]+wayve_place, buffer, size);
         wayve_place = 0;
         wayve();
         return;
      }
      if (size < temp) { 
         memcpy(&wayve_buf[place]+wayve_place, buffer, size);
	 wayve_place += size;
         return;
      }
      memcpy(&wayve_buf[place]+wayve_place, buffer, temp);
      wayve_place = 0;
      wayve();
      do_analysis(buffer+temp, size - temp);
      return;
   }
   memcpy(&wayve_buf[place]+wayve_place, buffer, size);
   wayve_place = 0;
   wayve();
}

int init_analysis(Window win, int w, int h)
{
   int size;
   int num;
   wayve_w = w;
   wayve_h = h;
   wayve_win = win;
   wayve_bufsize = size = ((44100/h)/wayve_fps)*w;
   wayve_lag = (wayve_lag*1200)/size;
   num = wayve_lag + 2;
   wayve_bufnum = num;
   wayve_buf = (short*)calloc(size*4*num+40, sizeof(short));
   wayve_num = 0;
   wayve_p = (XPoint*)calloc(w*2, sizeof(XPoint));
   return wayve_bufsize*4;
}

void close_analysis(void)
{
   if (wayve_buf) 
      free(wayve_buf);
   wayve_buf = NULL;
   if (wayve_p)
      free(wayve_p);
   wayve_p = NULL;
}

void version_info(char *id, char *version, char *copyright)
{
   strcpy(id, "wayve");
   strcpy(version, "0.2");
   strcpy(copyright, "1996-1998 Carsten Haitzler");
}

