#include "emusic.h"

#ifdef HAVE_SOUND
#include <esd.h>
#endif

Window analyze_win = 0;

int turnOnAnalysis = FALSE;
int turnOffAnalysis = FALSE;
int toggleAnalysisType = FALSE;
int shutdownAnalysis = FALSE;
int do_the_analysis = FALSE;

char *an_buffer = NULL;

extern pthread_mutex_t buffer_mutex;

void init_analyze(Window win)
{
   int w, h;
   XWindowAttributes attr;
   int an_buffer_size = AUSIZ;
   if (!win) { 
      do_the_analysis = FALSE;
      return;  
   }
   XGetWindowAttributes(disp, win, &attr);
   w = attr.width;
   h = attr.height;
   analysis->current->size = analysis->current->init_analysis(win, w, h); 
   an_buffer = (char*)calloc(an_buffer_size,sizeof(char));
   analyze_win = win;
   do_the_analysis = TRUE;
}

void analyze(char *buffer, int size)
{
   if (do_the_analysis && playing && buffer && size) 
      analysis->current->do_analysis(buffer, size);
}

void really_close_analyze(void)
{
}

void close_analyze(void)
{
   analysis->current->close_analysis(); 
   XClearWindow(disp, analyze_win);
   if (an_buffer)
      free(an_buffer);
   an_buffer = NULL;
   do_the_analysis = FALSE;
}

void toggle_analyze(void)
{
   close_analyze();
   analysis->current = analysis->current->next;
   if (!analysis->current)
     analysis->current = analysis->first; 
   init_analyze(analyze_win);
}

void analysis_loop(void)
{
   int read_esd = 0;
   pthread_setcancelstate(PTHREAD_CANCEL_DISABLE, NULL);
   while (1) {
      if (turnOnAnalysis) {
         if (!do_the_analysis)
            init_analyze(analyze_win);
	 turnOnAnalysis = FALSE;
      }
      if (turnOffAnalysis) {
         if (do_the_analysis)
            close_analyze();
         turnOffAnalysis = FALSE;
      }
      if (toggleAnalysisType) {
         if (do_the_analysis)
            toggle_analyze();
         toggleAnalysisType = FALSE;
      }
      if (shutdownAnalysis) {
	 if (do_the_analysis)
            close_analyze();
	 really_close_analyze();
	 shutdownAnalysis = FALSE;
      }
      usleep(100);
      if (audioBuffer.bufferPtr) {
         pthread_mutex_lock(&buffer_mutex);
         if ((AUDIO_BUFFER_SIZE - audioBuffer.outPos) >= 0)
            memcpy(an_buffer, audioBuffer.bufferPtr + audioBuffer.outPos, AUSIZ);
         read_esd = AUSIZ;
         pthread_mutex_unlock(&buffer_mutex);
      }
      analyze(an_buffer, read_esd);
   }
}

void SpawnAnalysis(void)
{
   pthread_t analysis_thread;
   char dir[1024];
   sprintf(dir, "%s/%s", EMUSICDIR,"analyzers");
   InitAnalysis(dir);
   pthread_create(&analysis_thread, NULL, (void *)analysis_loop, NULL);
   pthread_detach(analysis_thread);
}

void SetAnalysisWin(Window win)
{
   analyze_win = win;
   turnOnAnalysis = TRUE;
}

void KillAnalysisWin(void)
{
   turnOffAnalysis = TRUE;
}

void ToggleAnalysisType(void)
{
   toggleAnalysisType = TRUE;
}

void ShutdownAnalysis(void)
{
   shutdownAnalysis = TRUE;
}
