#include "audio.h"

#include <unistd.h>

int old_freq = -1;
int old_stereo = -1;
int old_sign = -1;
int old_big = -1;
int old_sixteen = -1;
int old_bit = 0;
int volume = -1;

void set_bitrate(int bit)
{
   old_bit = bit;
}

void GetAudioStats(int *stereo, int *mono, int *bit, int *sample)
{
   if (playing || paused) {
      *stereo = old_stereo;
      if (old_stereo == 0)
         *mono = 1;
      else
         *mono = 0;
      *sample = (old_freq / 1000);
      *bit = old_bit;
      return;
   }
   *stereo = 0;
   *mono = 0;
   *bit = 0;
   *sample = 0;
}

int setup_audio(int frequency, int stereo, int sign, int big, int sixteen)
{
   if (!use_wave) { 
      if (AUDIO_BUFFER_SIZE==0) {
	 audioSetFormat(sign, big, sixteen);
	 if (audioOpen(frequency, stereo, volume)) {
	    fprintf(stderr,"Couldn't open audio, blah...\n");
	    exit(1);
	 }
      }
      else {
         if ((old_freq != frequency) || (old_stereo != stereo) || 
	     (old_sign != sign) || (old_big != big) || (old_sixteen != sixteen)
	     || (!buffer_running)) {
	    if (buffer_running) {
	        inputFinished = TRUE;
	        while (buffer_running)
	           usleep(100);
	        inputFinished = FALSE;
            }  
	    audioSetFormat(sign, big, sixteen);
	    audioBufferOpen(frequency, stereo, volume);
            old_freq = frequency;
	    old_stereo = stereo;
	    old_sign = sign;
	    old_big = big;
	    old_sixteen = sixteen;
         } 
      }
   }
   else {
      if (!(out_file = fopen("/dev/raw","w"))) {
         fprintf(stderr, "Could not open /dev/raw for output\n");
         fprintf(stderr, "Edit the MAIN config file and change use_wave t to f\n");
         return 1;
      }
   }
   return 0;

}

void close_audio(void)
{
  if (!use_wave) {
    if (AUDIO_BUFFER_SIZE != 0)
        audioBufferClose();
    else
	audioClose();
  }
  else {
     if (out_file) 
        fclose(out_file);
     out_file = NULL;
  } 
}

