#include "emusic.h"

char *tempskindir;

ImlibImage *LoadImlibImage(char *path)
{
   ImlibImage *im;
   if (!(im = Imlib_load_image(imlib, path))) {
      fprintf(stderr,"Something is deathly wrong..\n");
      exit(-1);
   }
   return im;
}

int ProcessImage(char *image, char *dest, int x, int y, int w, int h)
{
  char orig[512];
  char ppm[512];
  char temp[512];
  sprintf(orig,"%s", FindFile(image, origskin));
  if (strcmp(orig, "(null)")) {
     ImlibImage *im;
     sprintf(temp, "\"%s/%s\"", origskin, orig);
     im = LoadImlibImage(temp);
     Imlib_crop_image(imlib, im, x, y, w, h);
     sprintf(ppm, "%s/%s", tempskindir, dest);
     Imlib_save_image_to_ppm(imlib, im, ppm);
     Imlib_kill_image(imlib, im);
     return 1;
  }
  fprintf(stderr,"No %s in skin, falling back to Base\n", image);
  return 0;
}

void Convert_main(char *tempskindirlala)
{
   char orig[512];
   char ppm[512];
   char temp[512];
   tempskindir = tempskindirlala;
   sprintf(orig, "%s", FindFile("main.bmp", origskin));
   if (strcmp(orig, "(null)")) {
      ImlibImage *main_im, *ppm_im;
      ProcessImage("titlebar.bmp", "titlebar.ppm", 27, 0, 275, 14);
      sprintf(temp, "%s/titlebar.ppm", tempskindir);
      ppm_im = LoadImlibImage(temp);
      unlink(temp);
      ProcessImage("main.bmp", "main.ppm", 0, 0, 275, 116);
      sprintf(temp, "%s/main.ppm", tempskindir);
      main_im = LoadImlibImage(temp);
      memcpy(main_im->rgb_data, ppm_im->rgb_data, 11550);
      Imlib_changed_image(imlib, main_im);
      Imlib_save_image_to_ppm(imlib, main_im, temp);
      Imlib_kill_image(imlib, main_im);
      Imlib_kill_image(imlib, ppm_im);
   }
   else {
      sprintf(orig, "%s/%s", default_path, "main.ppm");
      sprintf(ppm,  "%s/%s", tempskindir, "main.ppm");
      cp(orig, ppm);
   }
}

void Convert_cbuttons(char *tempskindir)
{
   ProcessImage("cbuttons.bmp", "rw_0.ppm", 0, 0, 23, 18);
   ProcessImage("cbuttons.bmp", "rw_1.ppm", 0, 18, 23, 18);
   ProcessImage("cbuttons.bmp", "play_0.ppm", 23, 0, 23, 18);
   ProcessImage("cbuttons.bmp", "play_1.ppm", 23, 18, 23, 18);
   ProcessImage("cbuttons.bmp", "pause_0.ppm", 46, 0, 23, 18);
   ProcessImage("cbuttons.bmp", "pause_1.ppm", 46, 18, 23, 18);
   ProcessImage("cbuttons.bmp", "stop_0.ppm", 69, 0, 23, 18);
   ProcessImage("cbuttons.bmp", "stop_1.ppm", 69, 18, 23, 18);
   ProcessImage("cbuttons.bmp", "ff_0.ppm", 92, 0, 22, 18);
   ProcessImage("cbuttons.bmp", "ff_1.ppm", 92, 18, 22, 18);
   ProcessImage("cbuttons.bmp", "eject_0.ppm", 114, 0, 22, 16);
   ProcessImage("cbuttons.bmp", "eject_1.ppm", 114, 16, 22, 16);
}

void Convert_monoster(char *tempskindir)
{
   ProcessImage("monoster.bmp", "stereo_0.ppm", 0, 12, 29, 12);
   ProcessImage("monoster.bmp", "stereo_1.ppm", 0, 0, 29, 12);
   ProcessImage("monoster.bmp", "mono_0.ppm", 29, 12, 29, 12);
   ProcessImage("monoster.bmp", "mono_1.ppm", 29, 0, 29, 12);
}

void Convert_numbers(char *tempskindir)
{
   ProcessImage("numbers.bmp", "digit3.ppm", 0, 0, 99, 13);
}

void Convert_playpaus(char *tempskindir)
{
   ProcessImage("playpaus.bmp", "play_indicator.ppm", 0, 0, 9, 9);
   ProcessImage("playpaus.bmp", "pause_indicator.ppm", 9, 0, 9, 9);
   ProcessImage("playpaus.bmp", "stop_indicator.ppm", 18, 0, 9, 9);
}

void Convert_posbar(char *tempskindir)
{
   ProcessImage("posbar.bmp", "status_bar.ppm", 0, 0, 248, 10);
   ProcessImage("posbar.bmp", "slider_0.ppm", 248, 0, 29, 10);
   ProcessImage("posbar.bmp", "slider_1.ppm", 278, 0, 29, 10);
}

void Convert_shufrep(char *tempskindir)
{
   ProcessImage("shufrep.bmp", "bulb_0.ppm", 23, 61, 23, 12);
   ProcessImage("shufrep.bmp", "bulb_1.ppm", 69, 61, 23, 12);
   ProcessImage("shufrep.bmp", "bulb_2.ppm", 23, 73, 23, 12);
   ProcessImage("shufrep.bmp", "bulb_3.ppm", 69, 73, 23, 12);
   ProcessImage("shufrep.bmp", "shuffle_0.ppm", 28, 0, 47, 15);
   ProcessImage("shufrep.bmp", "shuffle_1.ppm", 28, 15, 47, 15);
   ProcessImage("shufrep.bmp", "shuffle_2.ppm", 28, 30, 47, 15);
   ProcessImage("shufrep.bmp", "shuffle_3.ppm", 28, 45, 47, 15);
   ProcessImage("shufrep.bmp", "repeat_0.ppm", 0, 0, 28, 15);
   ProcessImage("shufrep.bmp", "repeat_1.ppm", 0, 15, 28, 15);
   ProcessImage("shufrep.bmp", "repeat_2.ppm", 0, 30, 28, 15);
   ProcessImage("shufrep.bmp", "repeat_3.ppm", 0, 45, 28, 15);
   ProcessImage("shufrep.bmp", "eq_0.ppm", 0, 61, 23, 12);
   ProcessImage("shufrep.bmp", "eq_1.ppm", 46, 61, 23, 12);
   ProcessImage("shufrep.bmp", "eq_2.ppm", 0, 73, 23, 12);
   ProcessImage("shufrep.bmp", "eq_3.ppm", 46, 73, 23, 12);
}

void CutOutLetter(ImlibImage *im, int x, int y, unsigned char c)
{
  ImlibImage *copy_im;
  char ppm[512];
  int w = 5;
  if (c == '@')
     w = 6;
  copy_im = Imlib_clone_image(imlib, im);
  Imlib_crop_image(imlib, copy_im, x, y, w, 6);
  sprintf(ppm, "%s/winampfont/%d.ppm", tempskindir, c);
  Imlib_save_image_to_ppm(imlib, copy_im, ppm);
  Imlib_kill_image(imlib, copy_im);
}

void Convert_text(char *tempskindir)
{
   char text[512];
   ImlibImage *text_im;
   unsigned char c;
   int x = 0, y = 0;
   if (!ProcessImage("text.bmp", "text.ppm", 0, 0, 155, 18)) {
      fprintf(stderr,"Using the Base winampfont\n");
      return;
   }
   sprintf(text, "%s/text.ppm", tempskindir);
   text_im = LoadImlibImage(text);              
   for (c = 'A'; c <= 'Z'; c++) { 
      CutOutLetter(text_im, x, y, c);
      x += 5;
   }
   CutOutLetter(text_im, x, y, '"');
   x += 6;
   CutOutLetter(text_im, x, y, '@');
   x = 0; y += 6;
   for (c = '0'; c <= '9'; c++) {
      CutOutLetter(text_im, x, y, c);
      x += 5;
   }
   x += 10;
   CutOutLetter(text_im, x, y, ':'); x += 5;
   CutOutLetter(text_im, x, y, '('); x += 5;
   CutOutLetter(text_im, x, y, ')'); x += 5;
   CutOutLetter(text_im, x, y, '-'); x += 5;
   CutOutLetter(text_im, x, y, 39);  x += 5;
   CutOutLetter(text_im, x, y, '!'); x += 5;
   CutOutLetter(text_im, x, y, '_'); x += 5;
   CutOutLetter(text_im, x, y, '+'); x += 5;
   CutOutLetter(text_im, x, y, 92);  x += 5;
   CutOutLetter(text_im, x, y, 47);  x += 5;
   CutOutLetter(text_im, x, y, '['); x += 5;
   CutOutLetter(text_im, x, y, ']'); x += 5;
   CutOutLetter(text_im, x, y, '^'); x += 5;
   CutOutLetter(text_im, x, y, '&'); x += 5;
   CutOutLetter(text_im, x, y, '%'); x += 5;
   CutOutLetter(text_im, x, y, ','); x += 5;
   CutOutLetter(text_im, x, y, '='); x += 5;
   CutOutLetter(text_im, x, y, '$'); x += 5;
   CutOutLetter(text_im, x, y, '*'); x += 5;
   x = 0; y += 6;
   CutOutLetter(text_im, x, y, 143); x += 5;
   CutOutLetter(text_im, x, y, 153); x += 5;
   CutOutLetter(text_im, x, y, 142); x += 5;
   CutOutLetter(text_im, x, y, '?'); x += 5;
   CutOutLetter(text_im, x, y, 145); x += 5;
   CutOutLetter(text_im, x, y, ' ');
   unlink(text);
}

void Convert_titlebar(char *tempskindir)
{
   ProcessImage("titlebar.bmp", "close_0.ppm", 18, 0, 9, 9);
   ProcessImage("titlebar.bmp", "close_1.ppm", 18, 9, 9, 9);
}

void Convert_volume(char *tempskindir)
{
}
