#include "emusic.h"

#define UNDEF   0
#define MAIN    1
#define EMP3    2
#define PLIST   3
#define AMP     4
#define FILEWIN 5
#define AUDIO   6
#define INFO    7
#define ANALYZE 8
#define XMP     9
#define OLD     10
#define PLAYER  11

int currentline = 0;

void splitstring(char *left, char *right, char *data)
{
   sscanf(data,"%s %[^\n]", left, right);
   upstr(left);
}

char *upstr(char *src)
{
   int i;
   for (i = 0;i<strlen(src);i++)
     src[i] = toupper(src[i]);
   return src;
}

void getcoords(char *data, int *x, int *y)
{
   int n;
   n = sscanf(data, "%i %i", x, y);
   if (n < 2) {
      fprintf(stderr,"Not enough coords on line %i\n", currentline);
      exit(-1);
   }
}

int parsebool(char *data)
{
   data[0] = toupper(data[0]);
   if ((data[0] == 'T') || (data[0] == 'Y') || (data[0] == '1'))
      return TRUE;
   else if ((data[0] == 'F') || (data[0] == 'N') || (data[0] == '0'))
      return FALSE;
   else {
      fprintf(stderr, "Boolean %s at line %i is all funkified.\n", data, currentline);
      exit(-1);
   }
}

void _loadconfig(char *file)
{
   char home[512];
   char st[512];
   char s1[256], s2[256];
   FILE *in;
   struct player_plugin *config_player = NULL;
   int context = UNDEF;
   strcpy(home,getenv("HOME"));
   strcat(home,file);
   if ((in = fopen(home,"r")) == NULL) {
      char *homedir, *temp1, *temp2;
      fprintf(stderr,"Error, I can't find your %s, installing default\n",home);
      homedir = malloc(1024);
      strcpy(homedir,getenv("HOME"));
      strcat(homedir,"/.emusic");
      if (!isdir(homedir))
	 mkdir(homedir,S_IRWXU);
      free(homedir);
      temp1 = malloc(1024);
      strcpy(temp1, EMUSICDIR);
      temp2 = strrchr(file, '/');
      strcat(temp1, temp2);
      cp(temp1, home);
      if ((in = fopen(home,"r")) == NULL) {
         fprintf(stderr,"Error in copying %s to ~/.emusic, do it manually\n", 
                        temp1);
	 exit(-1);
      }
      free(temp1);
   }
   currentline = 1;
   while (fgets(st,512,in)) {
     if ((st[0] != '#') && (st[0] != '\n') && (st[0] != '\0')) {
	 splitstring(s1, s2, st);
	 if (!strncmp("BEGIN", s1,5)) {
	    if (!(config_player = ReturnPlayerPlugin(s2))) { 
	       upstr(s2);
	       if (!strncmp("MAIN", s2, 4)) context = MAIN;
	       else if (!strncmp("EMUSIC", s2, 4)) context = OLD;
	       else if (!strncmp("PLAYEDITWIN", s2, 5)) context = OLD;
	       else if (!strncmp("FILE",s2,4)) context = OLD;
	       else if (!strncmp("AUDIO",s2,5)) context = AUDIO;
	       else if (!strncmp("ANALYZE", s2, 8)) context = ANALYZE;
	       else context = UNDEF;
	    }
	    else 
	       context = PLAYER; 
	 }
	 if (context == MAIN)
	    ConfigMain(s1, s2);
	 else if (context == AUDIO)
	    ConfigAudio(s1, s2);
	 else if (context == PLAYER) 
	    config_player->config(s1, s2);
	 else if (context == OLD) {
	    fprintf(stderr,"old style config.. please update\n");
	    exit(-1);
	 }
	 if (!strncmp("END", s1, 3))
	    context = UNDEF;
     }
     currentline++;
   }
}

void loadconfig(char *path)
{
   int sucessful = FALSE;
   if (path) {
      _loadconfig(path);
      return;
   }
   if (themepath && !textmode) {
      sucessful = Load_Theme();
      if (!sucessful) {
	 fprintf(stderr,"Couldn't load %s, dying\n", themepath);
	 Unload_Theme(FALSE, NULL);
	 exit(-1);
      }
   }
   else if (!textmode) {
      fprintf(stderr,"No theme specified, and not in textmode, so I'm dying...\n");
      exit(-1);
   }
}

