#include "emusic.h"

FileBox *FileWin;

char *GetRightPath(char *path)
{
   char savepath[512];
   char *temp = NULL;
   if (!path)
      return NULL;
   getcwd(savepath, 512);
   if ((path[0] != '/') && (path[0] != '~')) {
      temp = malloc((strlen(savepath) + strlen(path)) + 2);
      sprintf(temp, "%s/%s", savepath, path);
   }
   else if (path[0] != '/') {
      strcpy(savepath, getenv("HOME"));
      temp = malloc((strlen(savepath) + strlen(path)));
      path++;
      sprintf(temp, "%s/%s", savepath, path);
   }
   else {
      temp = malloc(strlen(path) + 1);
      strcpy(temp, path);
   }
   return temp;
}

void rmrf(char *s1)
{
   char savepath[512];
   char temp[512];
   DIR *dir;
   struct dirent *entry;
   if (!(dir = opendir(s1))) 
      return;
   if (strncmp("/tmp", s1, 4)) {
      fprintf(stderr,"not going to delete %s\n", s1);
      chdir(savepath);
      closedir(dir);
      return;
   }
   getcwd(savepath, 512);
   chdir(s1);
   while ((entry = readdir(dir))) {
      if (isdir(entry->d_name)) {
	 if (!strcmp(".", entry->d_name) || !strcmp("..",entry->d_name))
	    continue;
	 sprintf(temp, "%s/%s", s1, entry->d_name);
	 rmrf(temp);
      }
      else if (isfile(entry->d_name))
	 unlink(entry->d_name);
   }
   chdir(savepath);
   rmdir(s1);
   closedir(dir);
}

int exists(char *s1)
{
   struct stat st;
   if ((!s1) || (!*s1))
      return 0;
   if (stat(s1, &st) == -1)
      return 0;
   return 1;
}

int isfile(char *s1)
{
   struct stat st;
   if ((!s1) || (!*s1))
      return 0;
   if (stat(s1, &st) == -1)
      return 0;
   if (S_ISREG(st.st_mode))
      return 1;
   return 0;
}

int isdir(char *s1)
{
   struct stat st;
   if ((!s1) || (!*s1))
      return 0;
   if (stat(s1, &st) == -1)
      return 0;
   if (S_ISDIR(st.st_mode))
      return 1;
   return 0;
}

char *FindFile(char *file, char *path)
{
   DIR *dir;
   struct dirent *entry;
   char temp[512];
   if ((dir = opendir(path)) == NULL)
      return NULL;
   while ((entry = readdir(dir))) {
      sprintf(temp, "%s/%s", path, entry->d_name);
      if (isfile(temp))
         if (!strcasecmp(entry->d_name, file)) {
            closedir(dir);
            return entry->d_name;
         }
   }
   closedir(dir);
   return NULL;
}

void cp(char *orig, char *dest)
{
   FILE *fs, *fd;
   unsigned char buf[1];

   if ((!orig) || (!dest) || (!*orig) || (!*dest)) 
      return;
   if (!exists(orig)) 
      return;
   fs = fopen(orig, "r");
   if (!fs) 
      return;
   fd = fopen(dest, "w");
   if (!fd) {
      fclose(fs);
      return;
   }
   while (fread(buf, 1, 1, fs))
      fwrite(buf, 1, 1, fd);
   fclose(fs);
   fclose(fd);
}

void GetTextModeList(void)
{
   char *temp;
   if (!chdir(textmodepath))
      dirtolist(textmodepath, "*", textmode_recursive);
   else {
      temp = splitdir(textmodepath);
      if (strlen(textmodepath) == 0)
	 dirtolist("/", temp, textmode_recursive);
      else 
	 dirtolist(textmodepath, temp, textmode_recursive);
   }
}

struct player_plugin *getfiletype(char *path)
{
   struct player_plugin *cur;
   cur = players->first;
   if (!cur->next)
      return cur;
   cur = cur->next;
   while (cur) {
      if (cur->is_file(path))
         return cur;
      cur = cur->next;
   }
   return players->first;
}

int cdtolist(char *path, int current_selection)
{
   FILE *temp;
   char *tempname;
   tempname = malloc(128);
   tmpnam(tempname);
   if (!(temp = fopen(tempname,"w"))) {
      free(tempname);
      return 0;
   }
   fprintf(temp, "%s\n",path);
   fclose(temp);
   addplaylist(tempname);
   unlink(tempname);
   return 1;
}

int dirtolist(char *path, char *mask, int recursive)
{
   FILE *temp;
   char *tempname;
   int i = 0;
   tempname = malloc(128);
   tmpnam(tempname);
   if (!(temp = fopen(tempname,"w"))) {
      free(tempname);
      return 0;
   }
   if (strlen(path) > 1)
      if (path[(strlen(path)-1)] == '/')
         path[(strlen(path)-1)] = '\0';
   i = dodirtolist(path, mask, temp, recursive);
   fclose(temp);
   if (!i)
      addplaylist(tempname);
   unlink(tempname);
   chdir(path);
   free(tempname);
   return i;
}

int dodirtolist(char *path, char *mask, FILE *file, int recursive)
{
   DIR *dir;
   struct dirent *entry;
   char cwd[512];
   char savepath[512];
   if (!(dir = opendir(path))) {
      fprintf(stderr,"Can't read directory: %s\n",path);
      return 1;
   }
   getcwd(savepath, 512);
   chdir(path);
   getcwd(cwd,512);
   while ((entry = readdir(dir))) {
      if (isdir(entry->d_name)) {
	 if (!strcmp(".",entry->d_name) || !strcmp("..",entry->d_name))
	    continue;
	 if (recursive)
	   dodirtolist(entry->d_name,mask,file,recursive);
      }
      else if (isfile(entry->d_name)) {
	 if (match(mask,entry->d_name)) {
	    if (strlen(cwd) == 1)
	       strcpy(cwd,"\0");
	    fprintf(file,"%s/%s\n",cwd,entry->d_name);
	 }
      }
   }
   chdir(savepath);
   closedir(dir);
   return 0;
}

int match(char *mask, char *str)
{
   if (!mask) return 1;
   if ((mask[0] == '\0') && (str[0] == '\0'))return 1;
   while ((mask[0] != '?') && (mask[0] != '*')) {
      if (mask[0] != str[0])
	 return 0;
      mask++;
      str++;
      if ((mask[0] == '\0') && (str[0] == '\0')) return 1;
   }
   if (mask[0] == '?') {
      mask++;
      str++;
      if ((mask[0] == '\0') && (str[0] == '\0')) return 1;
      else return match(mask,str);
   }
   else if (mask[0] == '*') {
      int i, j, done;
      char *temp, *temp2;
      mask++;
      if (mask[0] == '\0') return 1;
      temp = malloc(strlen(mask)+1);
      i = done = 0;
      if ((strchr(mask,'*')) || (strchr(mask,'?')))
	 while (!done) {
	    temp[i] = mask[0];
	    i++;
	    mask++;
	    if ((mask[0] == '?') || (mask[0] == '*'))
	       done = 1;
	 }
      else 
	while (!done) {
	   temp[i] = mask[0];
	   i++;
	   mask++;
	   if (mask[0] == '\0')
	      done = 1;
	}
      temp[i] = '\0';
      done = 0;
      temp2 = strchr(str,temp[0]);
      if (!temp2) { free(temp); return 0; }
      while (!done) {
	 for (j = 0;j < i;j++) {
	    if (temp[j] == temp2[j])
	       done = 1;
	    else {
	       free(temp);
	       return 0;
	    }
	 }
	 if (strchr(temp2,temp[0]) != temp2) {
	    temp2 = strchr(temp2,temp[0]);
	    done = 0;
	 }
      }
      for (j = 0; j < i; j++)
	 temp2++;
      str = temp2;
      free(temp);
      return match(mask,str);
   }
   else return match(mask,str);
}

char *splitdir(char *dir)
{
   char *name;
   if (!dir) return NULL;
   if (dir[strlen(dir)-1] == '/') 
     name = NULL;
   else {
      name = strrchr(dir,'/');
      if (!name) {
	name = malloc(strlen(dir)+1);
	strcpy(name, dir);
	strcpy(dir,"./");
      }
      else {
         name[0] = '\0';
         name++;
      }
   }
   return name;
}

void ConfigFile(FILE *file)
{
   if (textmode)
      return;
   FileWin = malloc(sizeof(FileBox));
   ConfigFileBox(FileWin, file);
}
