#include "emusic.h"

Widget *MainWin;
Button *digit[7];
Slider *timer_bar;
TextBox *name_box;
MultiButton *playbutton;
MultiButton *playmodebutton;

Window a_win;

int dummy;
int timedisplay = FALSE;
int trackdisplay = FALSE;

int lastmp3Redraw;
int lastSecond = 0;
int flash;
int time_mode;

StatusWin *statuswin;

void Create_MP3(void)
{
   int i;
   if (timedisplay)
      for(i = 0; i < 4; i++)
         SetButtonPart(digit[i], 11);
   if (trackdisplay)      
      for(i = 4; i <= 6; i++)
         SetButtonPart(digit[i], 0);
   control(STOP);
}

void Display_Main(void)
{
   int track[3];
   int cdtime[4];
   static int old_digit[7] = { -1, -1, -1, -1, -1, -1, -1 };
   static int old_time = -1;
   int i;
   int disp_time = 0;
   time_t flash_time;
   int frame = 0;
   frame = get_second();
   if (!frame)
      frame = cur_second;
   if (timer_bar) {
      if (timer_bar->dragging)
         frame = GetSliderPosition(timer_bar) * num_seconds;
      else
         SetSliderPosition(timer_bar, (float)frame / (float)num_seconds);
   }
   if (name_box) {
      if (cur_item)
         SetTextTextBox(name_box, cur_item->name);
      else 
	 SetTextTextBox(name_box, NULL);
      UpdateTextBox(name_box);
   }
   UpdateStatusWin(statuswin);
   if (!timedisplay)
      return;
   if (p_list[0] == '\0' || !cur_item) {
      for(i=0;i<4;i++)
         cdtime[i] = 11;
      for(i=0;i<3;i++)
         track[i] = 0;
      disp_time = 0;
   }
   else if (!playing && !paused) {
      if (cur_item)
         disp_time = cur_item->length;
      else disp_time = 0;
      cdtime[0] = 0;
      cdtime[1] = (disp_time / 60);
      if (cdtime[1] >= 10) {
         cdtime[0] = cdtime[1] / 10;
         cdtime[1] = cdtime[1] % 10;
      }
      cdtime[2] = ((disp_time % 60) / 10);
      cdtime[3] = (disp_time % 10);
      track[2] = ((cur_item->pos % 100) % 10);
      track[1] = ((cur_item->pos % 100) / 10);
      track[0] = (cur_item->pos / 100);
   }
   else {
      if (paused) {
         flash_time = tv.tv_sec;
         flash = ((flash_time % 2) == 1);
      }
      else flash = FALSE;
      track[2] = ((cur_item->pos % 100) % 10);
      track[1] = ((cur_item->pos % 100) / 10);
      track[0] = (cur_item->pos / 100);
      if (time_mode == 0) 
         disp_time = frame;
      else if (time_mode == 1) 
         disp_time = num_seconds - frame;
      else if (time_mode == 2) 
         disp_time = playlist->length;
      else 
         disp_time = playlist->length; 
      cdtime[0] = 0;
      cdtime[1] = (disp_time / 60);
      if (cdtime[1] >= 10) {
         cdtime[0] = cdtime[1] / 10;
         cdtime[1] = cdtime[1] % 10;
      }
      cdtime[2] = ((disp_time % 60) / 10);
      cdtime[3] = (disp_time % 10);
      if(flash) {
         for(i = 0;i < 4; i++) cdtime[i]=11;
      }
   }
   if (disp_time != old_time) {
      for(i = 0; i < 4; i++)
         if (old_digit[i] != cdtime[i]) {
            SetButtonPart(digit[i], cdtime[i]);
	    old_digit[i] = cdtime[i];
         }
      old_time = disp_time;  
   }   
   if (trackdisplay) {
      for(i = 4; i <= 6; i++)
         if (old_digit[i] != track[i-4]) {
            SetButtonPart(digit[i], track[i-4]);
            old_digit[i] = track[i-4];
         }
   }
}

void Event_Main(XEvent ev)
{
   if (!FindEventWidget(MainWin, ev)) {
      if ((ev.type == ButtonPress) && (ev.xbutton.window == MainWin->win)) {
	 moving = TRUE;
	 move_x = ev.xbutton.x;
	 move_y = ev.xbutton.y;
      }
      else if ((ev.type == ButtonRelease) && 
	       (ev.xbutton.window == MainWin->win)) {
	 if (ev.xbutton.button == 3) {
	    RaiseLowerWidget(MainWin);
	    if (PlayWin->visible)
	       RaiseLowerWidget(PlayWin);
	 }
	 else
	    moving = FALSE;
      }
   }
}

void ChangePlayType(void)
{
  switch(playtype) {
  case SHUFFLE: ShuffleIt(); break;
  default: break;
  }
  if (PlayWin->visible)
     DisplayListBox(listbox);
}

void Defaults_eMusic(void)
{
   timedisplay = FALSE;
   trackdisplay = FALSE;
   MainWin = NULL;
   timer_bar = NULL;
   name_box = NULL;
   playbutton = NULL;
   playmodebutton = NULL;
   digit[0] = digit[1] = digit[2] = digit[3] = digit[4] = digit[5] = digit[6] = NULL;
}

void ConfigEmp3(FILE *file)
{
   char st[256];
   char s1[128], s2[128];
   struct _widget *cur = NULL;
   int counter = 0;
   int digit_count = 0;
   int track_count = 4;
   int end = FALSE;
   Defaults_eMusic();
   if (textmode)
      return;
   MainWin = NULL;
   while (!end) {
      if (!fgets(st, 256, file)) {
	 fprintf(stderr,"Unexpected EOF in config file\n");
	 exit(-1);
      }
      strcpy(s1, "     ");  /* needed to kill odd bug... ugly, yes.. hrm */
      if ((st[0] != '#') && (st[0] != '\n') && (st[0] != '\0')) {
	 splitstring(s1, s2, st);
	 if (!strncmp("END", s1, 3))
	    end = TRUE;
         else if (!strncmp("TIMERMODE", s1, 9))
            time_mode = atoi(s2);
	 else if (!strncmp("BEGIN", s1, 5)) {
	    upstr(s2);
	    if (!MainWin) {
	       MainWin = malloc(sizeof(Widget));
	       MainWin->visible = TRUE;
	       MainWin->raised = TRUE;
	       MainWin->first = malloc(sizeof(struct _widget));
	       MainWin->win = root;
	       cur = MainWin->first;
	       MainWin->x = MainWin->y = 0;
	    }
	    else {
	       cur->next = malloc(sizeof(struct _widget));
	       cur = cur->next;
	    }
	    MainWin->last = cur;
	    cur->next = NULL;
	    if (!strncmp("BACKGROUND", s2, 9)) {
	       cur->type = BACKGROUND;
	       cur->widget = malloc(sizeof(Background));
	       ConfigBack(cur->widget, file);
	       MainWin->win = ((Background *)cur->widget)->win;
	       MainWin->shaped = ((Background *)cur->widget)->shaped;
	    }
	    else if (!strncmp("ANALYSIS", s2, 8)) {
	       cur->type = CONTAINER;
	       cur->widget = malloc(sizeof(Container));
	       ConfigContainer(cur->widget, MainWin->win, file);
	       SetAnalysisWin(((Container *)cur->widget)->win);
            }
	    else if (!strncmp("BUTTON", s2, 6)) {
	       cur->type = BUTTON;
	       cur->widget = malloc(sizeof(Button));
	       ConfigButton(cur->widget, MainWin->win, file);
	    }
	    else if (!strncmp("MULTIBUTTON", s2, 11)) {
	       cur->type = MULTIBUTTON;
	       cur->widget = malloc(sizeof(MultiButton));
	       ConfigMultiButton(cur->widget, MainWin->win, file, &dummy);
	    }
	    else if (!strncmp("PLAYTYPE", s2, 8)) {
	       if (!counter) {
	          cur->type = MULTIBUTTON;
	          cur->widget = malloc(sizeof(MultiButton));
	          ConfigMultiButton(cur->widget, MainWin->win, file, &playtype);
	          counter = 1;
	       }
	    }
	    else if (!strncmp("REPEATMODE", s2, 10)) {
	       cur->type = MULTIBUTTON;
	       cur->widget = malloc(sizeof(MultiButton));
	       ConfigMultiButton(cur->widget, MainWin->win, file, &repeat_mode);
	    }
	    else if (!strncmp("PLAYBUTTON", s2, 10)) {
	       cur->type = MULTIBUTTON;
	       cur->widget = malloc(sizeof(MultiButton));
	       ConfigMultiButton(cur->widget, MainWin->win, file, &dummy);
	       playbutton = cur->widget;
	    }
	    else if (!strncmp("PLAYMODE", s2, 8)) {
	       cur->type = MULTIBUTTON;
	       cur->widget = malloc(sizeof(MultiButton));
	       ConfigMultiButton(cur->widget, MainWin->win, file, &dumbcdmode);
	       playmodebutton = cur->widget;
	    }
	    else if (!strncmp("SLIDER", s2, 6)) {
	       cur->type = SLIDER;
	       cur->widget = malloc(sizeof(Slider));
	       timer_bar = cur->widget;
	       ConfigSlider(cur->widget, MainWin->win, file);
	    }
	    else if (!strncmp("TIME_DIGIT", s2, 5)) {
	       timedisplay = TRUE;
	       cur->type = BUTTON;
	       cur->widget = malloc(sizeof(Button));
	       digit[digit_count] = cur->widget;
	       ConfigButton(cur->widget, MainWin->win, file);
	       digit_count++;
	    }
	    else if (!strncmp("TRACK_DIGIT", s2, 5)) {
	       trackdisplay = TRUE;
	       cur->type = BUTTON;
	       cur->widget = malloc(sizeof(Button));
	       digit[track_count] = cur->widget;
	       ConfigButton(cur->widget, MainWin->win, file);
	       track_count++;
	    }
	    else if (!strncmp("COLON", s2, 5)) {
	       cur->type = BUTTON;
	       cur->widget = malloc(sizeof(Button));
	       ConfigButton(cur->widget, MainWin->win, file);
	       SetButtonPart(cur->widget, 10);
	    }
	    else if (!strncmp("NAME", s2, 4)) {
	       cur->type = TEXTBOX;
	       cur->widget = malloc(sizeof(TextBox));
	       ConfigTextBox(cur->widget, MainWin->win, file);
	       name_box = cur->widget;
	    }
	    else if (!strncmp("STATUS", s2, 6)) {
	       statuswin = malloc(sizeof(StatusWin));
	       ConfigStatusWin(statuswin, MainWin->win, file);
	    }
	 }
	 else
	   /*  fprintf(stderr,"Unknown line in MainWin config\n"); */ ;
      }
   } 
   Create_MP3();
   XSync(disp, False);
}
