#include "emusic.h"

Players *players = NULL;
Analysis *analysis = NULL;

void seek_to_frame_none(int second)
{
}

int play_none(int start_second, char *song)
{
   fprintf(stderr,"no player can handle %s, bug me about it..\n", song);
   return 0;
}

void pause_it_none(void)
{
}

void stop_none(void)
{
}

int get_length_none(char *song)
{
  return 0;
}

void set_name_none(struct playlist_item *song)
{
   strcpy(song->name, (char *)strrchr(song->path, '/') + 1);
}

int is_file_none(char *path)
{
   return TRUE;
}

void get_info_none(struct playlist_item *song)
{
}

struct player_plugin *DummyPlayer(void)
{
   struct player_plugin *cur;
   cur = malloc(sizeof(struct player_plugin));
   cur->init = NULL;
   cur->config = NULL;
   cur->seek_to_frame = seek_to_frame_none;
   cur->play = play_none;
   cur->pause_it = pause_it_none;
   cur->stop = stop_none;
   cur->get_length = get_length_none;
   cur->set_name = set_name_none;
   cur->is_file = is_file_none;
   cur->get_info = get_info_none;
   cur->id = malloc(13);
   strcpy(cur->id, "Dummy player");
   cur->version = malloc(4);
   strcpy(cur->version,"0.0");
   cur->version_info = NULL;
   cur->loaded = TRUE;
   cur->next = NULL;
   cur->handle = NULL;
   return cur;
}

struct player_plugin *ReturnPlayerPlugin(char *search)
{
   struct player_plugin *cur;
   if (!players)
      return NULL;
   cur = players->first;
   while (cur) {
      if (!strcasecmp(search, cur->id))
         return cur;
      if (strstr(cur->id, search))
         return cur;
      cur = cur->next;
   }
   return NULL;
}

void InitPlayers(char *path)
{
   struct player_plugin *cur = NULL;
   char *tempname;
   char *buffer;
   char soname[256];
   FILE *temp;
   void *handle = NULL;
   int i = 0;
   players = malloc(sizeof(Players));
   players->first = DummyPlayer();
   cur = players->first;
   players->number = 1;
   tempname = malloc(128);
   tmpnam(tempname);
   if (!(temp = fopen(tempname,"w"))) {
      fprintf(stderr,"Couldn't read modules from %s\n", path);
      free(tempname);
      return;
   }
   if (strlen(path) > 1)
      if (path[(strlen(path)-1)] == '/')
         path[(strlen(path)-1)] = '\0';
   i = dodirtolist(path, "*.so.0", temp, 0);
   fclose(temp);
   fprintf(stderr,"     Player Modules:\n");
   if (!i) {
      if (!(temp = fopen(tempname, "r"))) {
         fprintf(stderr,"Couldn't read modules from %s\n", path);
         free(tempname);
         return;
      }
      buffer = malloc(256);
      memset(buffer,0,256);
      cur->next = malloc(sizeof(struct player_plugin));
      while (fgets(buffer, 256, temp)) {
      	 buffer[(strlen(buffer)-1)] = '\0';
         strcpy(soname, buffer);
         handle = dlopen(soname, RTLD_NOW);
         if (handle) {
            char *error;
            char id[50];
            char version[50];
            char copyright[100];
            cur = cur->next;
            cur->handle = handle;
            cur->init = dlsym(handle, "init");
            cur->config = dlsym(handle, "config");
            cur->seek_to_frame = dlsym(handle, "seek_to_frame");
            cur->play = dlsym(handle, "play");
            cur->pause_it = dlsym(handle, "pause_it");
            cur->stop = dlsym(handle, "stop");
            cur->get_length = dlsym(handle, "get_length");
            cur->set_name = dlsym(handle, "set_name");
            cur->is_file = dlsym(handle, "is_file");
            cur->get_info = dlsym(handle, "get_info");
            cur->version_info = dlsym(handle, "version_info");
            if ((error = dlerror()) != NULL) {
               fprintf(stderr, "%s\n", error);
               exit(-1);
            }
            (*cur->version_info)(id, version, copyright);
            printf("\t%s %s, (C) %s\n", id, version, copyright);
            cur->id = malloc(strlen(id)+1);
            strcpy(cur->id, id);
            cur->version = malloc(strlen(version)+1);
            strcpy(cur->version, version);
            cur->copyright = malloc(strlen(copyright)+1);
            strcpy(cur->copyright, copyright);
            cur->loaded = TRUE;
            cur->init();
            players->number++;
         }
         else {
            fprintf(stderr, "%s\n", dlerror());
            exit(-1);
         }
         cur->next = malloc(sizeof(struct player_plugin));
      }
      players->current = players->first;
      fclose(temp);
   }
   if (cur->next)
      free(cur->next);
   cur->next = NULL;
   unlink(tempname);
   free(tempname);
   printf("\n");
   return;
}

void FreePlayers(void)
{
   struct player_plugin *cur, *prev;
   if (!players)
      return;
   fprintf(stderr,"freeing players\n");
   cur = players->first;
   while (cur) {
      prev = cur;
      cur = cur->next;
      dlclose(prev->handle);
      free(prev->id);
      free(prev->version);
      free(prev->copyright);
      free(prev);
      prev = NULL;
   }
   free(players);
   players = NULL;
}

int init_analysis_none(Window win, int w, int h)
{
   return 0;
}

void do_analysis_none(char *buffer, int size)
{
   usleep(500);
}

void close_analysis_none(void)
{
}

struct analysis_plugin *DummyAnalysis(void)
{
   struct analysis_plugin *cur;
   cur = malloc(sizeof(struct analysis_plugin));
   cur->init_analysis = init_analysis_none;
   cur->do_analysis = do_analysis_none;
   cur->close_analysis = close_analysis_none;
   cur->version_info = NULL;
   cur->id = malloc(5);
   strcpy(cur->id, "none");
   cur->version = NULL;
   cur->copyright = NULL;
   cur->handle = NULL;
   cur->next = NULL;
   return cur;
}

void InitAnalysis(char *path)
{
   struct analysis_plugin *cur = NULL;
   char *tempname;
   char *buffer;
   char soname[256];
   FILE *temp;
   void *handle = NULL;
   int i = 0;
   analysis = malloc(sizeof(Analysis));
   analysis->first = DummyAnalysis();
   cur = analysis->first;
   analysis->number = 1;
   tempname = malloc(128);
   tmpnam(tempname);
   if (!(temp = fopen(tempname,"w"))) {
      fprintf(stderr,"Couldn't read modules from %s\n", path);
      free(tempname);
      return;
   }
   if (strlen(path) > 1)
      if (path[(strlen(path)-1)] == '/')
         path[(strlen(path)-1)] = '\0';
   i = dodirtolist(path, "*.so.0", temp, 0);
   fclose(temp);
   printf("     Analysis Modules:\n");
   if (!i) {
      if (!(temp = fopen(tempname, "r"))) {
         fprintf(stderr,"Couldn't read modules from %s\n", path);
         free(tempname);
         return;
      }
      buffer = malloc(256);
      memset(buffer, 0, 256);
      cur->next = malloc(sizeof(struct analysis_plugin));
      while (fgets(buffer, 256, temp)) {
         buffer[(strlen(buffer)-1)] = '\0';
         strcpy(soname, buffer);
         handle = dlopen(soname, RTLD_NOW);
         if (handle) {
            char *error;
            char id[50];
            char version[50];
            char copyright[100];
            cur = cur->next;
            cur->handle = handle;
            cur->init_analysis = dlsym(handle, "init_analysis");
            cur->do_analysis = dlsym(handle, "do_analysis");
            cur->close_analysis = dlsym(handle, "close_analysis");
            cur->version_info = dlsym(handle, "version_info");
            if ((error = dlerror()) != NULL) {
               fprintf(stderr,"%s\n", error);
               exit(-1);
            }
            (*cur->version_info)(id, version, copyright);
            printf("\t%s %s, (C) %s\n", id, version, copyright);
            cur->id = malloc(strlen(id)+1);
            strcpy(cur->id, id);
            cur->version = malloc(strlen(version)+1);
            strcpy(cur->version, version);
            cur->copyright = malloc(strlen(copyright)+1);
            strcpy(cur->copyright, copyright);
            analysis->number++;
         }
         else { 
            fprintf(stderr, "%s\n", dlerror());
            exit(-1);
         }
         cur->next = malloc(sizeof(struct analysis_plugin));
      }
      analysis->current = analysis->first;
      fclose(temp);
   }
   if (cur->next)
      free(cur->next);
   cur->next = NULL;
   unlink(tempname);
   free(tempname);
   printf("\n");
   return;
}

void FreeAnalysis(void)
{
   struct analysis_plugin *cur, *prev;
   if (!analysis)
      return;
   cur = analysis->first;
   while (cur) {
      prev = cur;
      cur = cur->next;
      free(prev->id);
      free(prev->version);
      free(prev->copyright);
      free(prev);
      prev = NULL;
   }
   free(analysis);
   analysis = NULL;
}

int getnumtracks_cda(void)
{
   struct player_plugin *cd;
   int (*getnumtracks)(void);
   cd = ReturnPlayerPlugin("cd");
   getnumtracks = dlsym(cd->handle, "getnumtracks");
   if (!getnumtracks)
      return 0;
   return getnumtracks();
}
