#include "emusic.h"

char *origskin;
char *default_path;

int isSkinZip(char *path)
{
   char *temp;
   if (!path)
      return FALSE;
   if ((temp = strrchr(path, '.')) && (temp+3)) {
      if (!strcasecmp((temp+1), "zip"))
         return TRUE;
   }
   return FALSE;
}

char *FindSkin(char *path)
{
   char *returnpath = NULL;
   DIR *dir;
   struct dirent *entry;
   char temp[512];
   if (CheckForSkinAt(path)) {
      returnpath = malloc(strlen(path) + 1);
      strcpy(returnpath, path);
      return returnpath;
   }
   if ((dir = opendir(path)) == NULL)
      return NULL;
   while ((entry = readdir(dir))) {
      sprintf(temp, "%s/%s", path, entry->d_name);
      if (isdir(temp)) {
         if (strcmp(".", entry->d_name) && strcmp("..", entry->d_name)) { 
            returnpath = FindSkin(temp);
            if (returnpath)
               return returnpath;
         }
      }
   }
   closedir(dir);
   return NULL;
}
   

int CheckForSkinAt(char *path)
{
   if (FindFile("main.bmp", path))
     return TRUE;
   if (FindFile("cbuttons.bmp", path))
     return TRUE;
   if (FindFile("monoster.bmp", path))
     return TRUE;
   if (FindFile("numbers.bmp", path))
     return TRUE;
   if (FindFile("playpaus.bmp", path))
     return TRUE;
   if (FindFile("posbar.bmp", path))
     return TRUE;
   if (FindFile("shufrep.bmp", path))
     return TRUE;
   if (FindFile("text.bmp", path))
     return TRUE;
   if (FindFile("titlebar.bmp", path))
     return TRUE;
   if (FindFile("volume.bmp", path))
     return TRUE;
   return FALSE;
}

char *OpenTempDir(void)
{
   int i;
   static int number = 0;
   char temppath[256];
   char *tempskindir;
   i = getpid();
   sprintf(temppath,"/tmp/emusic_convert_%i_%i",i,number);
   number++;
   mkdir(temppath, S_IRWXU);
   tempskindir = malloc(strlen(temppath) + 1);
   strcpy(tempskindir, temppath);
   return tempskindir;
}

void Convert(char *ts)
{
   char sys[2048]; 
   sprintf(sys,"cp -r %s/* %s/", default_path, ts);
/* */ 
   system(sys);
   Convert_main(ts);
   Convert_cbuttons(ts);
   Convert_monoster(ts);
   Convert_numbers(ts);
   Convert_playpaus(ts);
   Convert_posbar(ts);
   Convert_shufrep(ts);
   Convert_text(ts);
   Convert_titlebar(ts);
   Convert_volume(ts);
}

void MakeThemeBall(char *tempskindir, char *savepath)
{
   char s[1024];
   sprintf(s, "(cd %s ; tar -c * | gzip -- > %s)", tempskindir, savepath);
   system(s);
}

int Convert_Skin(char *path)
{
  char *tempskindir;
  origskin = FindSkin(path);
  if (!origskin) {
     fprintf(stderr,"Can't find a skin anywhere below %s\n", path);
     return 1; 
  }
  tempskindir = path;
  Convert(tempskindir); 
  return 0;
}

int ConvertSkinToThemeball(char *path, char *savepath)
{
   char *tempskindir = NULL;
   char *temptempdir = NULL;
   char s1[1024];
   if (isSkinZip(path)) {
      temptempdir = OpenTempDir();
      sprintf(s1,"unzip %s -d %s > /dev/null", path, temptempdir);
      system(s1);
   }
   else {
      temptempdir = malloc(strlen(path)+1);
      strcpy(temptempdir, path);
   }
   origskin = FindSkin(temptempdir);
   if (!origskin) {
      fprintf(stderr,"Couldn't find skin at %s, exiting\n", path);
      return 1;
   }
   tempskindir = OpenTempDir(); 
   Convert(tempskindir);
   MakeThemeBall(tempskindir, savepath);
   rmrf(tempskindir); 
   if (strcmp(temptempdir, path))
     rmrf(temptempdir);
   fprintf(stderr,"Finished making themeball of %s\n", path);
   return 0;
}
