#include "../emusic.h"

void do_action(int action)
{
   switch (action) {
   case A_UNDEFINED:
   case A_NOTHING: break;
   case A_PLAY: control(PLAY); break;
   case A_PAUSE: control(PAUSE); break;
   case A_STOP: control(STOP);
                SetMultiButton(playbutton, 1); break;
   case A_FF: control(CUE); break;
   case A_REW: control(REV); break;
   case A_DOWNTRACK: control(DNTRACK); break;
   case A_FIRST: control(FIRST); break;
   case A_UPTRACK: control(UPTRACK); break;
   case A_PLAYLIST_TOGGLE: TogglePlayWin(); break;
   case A_LAST: control(LAST); break;
   case A_DIRECTACCESS: control(DIRECTACCESS); break;
   case A_MINIMIZE: break;
   case A_ICONIFY: break;
   case A_PLAYMODES: switchmodes(); break;
   case A_PLAYTYPE: ChangePlayType(); break;
   case A_RAISE_LOWER: break;
   case A_MOVE: break;
   case A_EXIT: Shutdown(); break; 
   case A_SORTLIST: sort_list(playlist, 1); break;
   case A_ADD_CD_TRACK: FileWin->cdmode = TRUE; 
                        PopUpFileBox(FileWin);
                        SetFileBoxCallback(FileWin, PlayWin_Callback);
			actiontype = ADD; break;
   case A_ADD_TRACK: FileWin->cdmode = FALSE;
                     PopUpFileBox(FileWin);
                     SetFileBoxCallback(FileWin, PlayWin_Callback);
                     actiontype = ADD; break;
   case A_DELETE_ALL: clearplaylist(playlist); 
                      CheckToPlay(); 
		      DisplayListBox(listbox); break;
   case A_DELETE_ONE: delete_one(listbox->current_selection); 
                      CheckToPlay(); 
		      DisplayListBox(listbox); break;
   case A_SAVE_LIST: FileWin->cdmode = FALSE;
   		     PopUpFileBox(FileWin);
   		     SetFileBoxCallback(FileWin, PlayWin_Callback);
                     actiontype = SAVE; break;
   case A_LOAD_LIST: FileWin->cdmode = FALSE;
   		     PopUpFileBox(FileWin);
   		     SetFileBoxCallback(FileWin, PlayWin_Callback);
                     actiontype = LOAD; break;
   case A_MOVE_DOWN: move_one(listbox->current_selection, 1);
                     if ((listbox->list) && (listbox->list->last) && 
                       (listbox->current_selection != listbox->list->last->pos))
                        listbox->current_selection++;
		     DisplayListBox(listbox); break;
   case A_MOVE_UP: move_one(listbox->current_selection, 0);
                   if (listbox->current_selection != 1)
                      listbox->current_selection--;
		   DisplayListBox(listbox); break;
   case A_SELECT_CUR_P: Select_Current(listbox->current_selection); break;
   case A_FILE_OK: FileWin->okdone = TRUE;
                   KillFileBox(FileWin); break; 
   case A_FILE_CANCEL: FileWin->okdone = FALSE;
                       KillFileBox(FileWin); break;
   case A_SELECT_CUR_F: SelectCurrentFileFileBox(FileWin, FileWin->filelist->current_selection); break;
   case A_CHANGE_ANALYSIS: ToggleAnalysisType(); break;
   case A_SHUFFLE: ShuffleIt(); break;
   case A_NEWTHEME: FileWin->cdmode = FALSE;
   		    PopUpFileBox(FileWin);
   		    SetFileBoxCallback(FileWin, Theme_Callback); break;
   default: break;
   }
}

int parse_action(char *text)
{
   upstr(text);
   if (!strcmp("NOTHING", text))
      return A_NOTHING;
   else if (!strcmp("PLAY", text))
      return A_PLAY;
   else if (!strcmp("PAUSE", text))
      return A_PAUSE;
   else if (!strcmp("STOP", text))
      return A_STOP;
   else if (!strcmp("FF", text))
      return A_FF;
   else if (!strcmp("REW", text))
      return A_REW;
   else if (!strcmp("DOWNTRACK", text))
      return A_DOWNTRACK;
   else if (!strcmp("FIRST", text))
      return A_FIRST;
   else if (!strcmp("TOGGLE_PLAYLIST", text))
      return A_PLAYLIST_TOGGLE;
   else if (!strcmp("UPTRACK", text))
      return A_UPTRACK;
   else if (!strcmp("LAST", text))
      return A_LAST;
   else if (!strcmp("SEEK", text))
      return A_DIRECTACCESS;
   else if (!strcmp("MINIMIZE", text))
      return A_MINIMIZE;
   else if (!strcmp("ICONIFY", text))
      return A_ICONIFY;
   else if (!strcmp("CHANGE_PLAYMODE", text))
      return A_PLAYMODES;
   else if (!strcmp("CHANGE_PLAYTYPE", text))
      return A_PLAYTYPE;
   else if (!strcmp("RAISE_LOWER", text))
      return A_RAISE_LOWER;
   else if (!strcmp("MOVE", text))
      return A_MOVE;
   else if (!strcmp("EXIT", text))
      return A_EXIT;
   else if (!strcmp("SORTLIST", text))
      return A_SORTLIST;
   else if (!strcmp("ADD_CD_TRACK", text))
      return A_ADD_CD_TRACK;
   else if (!strcmp("ADD_TRACK", text))
      return A_ADD_TRACK;
   else if (!strcmp("DELETE_ALL", text))
      return A_DELETE_ALL;
   else if (!strcmp("DELETE", text))
      return A_DELETE_ONE;
   else if (!strcmp("SAVE_LIST", text))
      return A_SAVE_LIST;
   else if (!strcmp("LOAD_LIST", text))
      return A_LOAD_LIST;
   else if (!strcmp("MOVE_UP", text))
      return A_MOVE_UP;
   else if (!strcmp("MOVE_DOWN", text))
      return A_MOVE_DOWN;
   else if (!strcmp("PLAYLIST_DOUBLECLICK", text))
      return A_SELECT_CUR_P;
   else if (!strcmp("FILEBOX_OK", text))
      return A_FILE_OK;
   else if (!strcmp("FILEBOX_CANCEL", text))
      return A_FILE_CANCEL;
   else if (!strcmp("FILEBOX_DOUBLECLICK", text))
      return A_SELECT_CUR_F;
   else if (!strcmp("CHANGE_ANALYSIS", text))
      return A_CHANGE_ANALYSIS;
   else if (!strcmp("SHUFFLE", text))
      return A_SHUFFLE;
   else if (!strcmp("NEWTHEME", text))
      return A_NEWTHEME;
   else 
      fprintf(stderr,"Action %s undefined..\n",text);
   return A_UNDEFINED;
}
