#include "../emusic.h"

void InitX(void)
{
  XGCValues gcvals;
  int black;

  XInitThreads();
  if ((disp = XOpenDisplay(NULL)) == NULL) {
     fprintf(stderr,"Can't open Display\n");
     exit(-1);
  }
  screen = DefaultScreen(disp);
  root = DefaultRootWindow(disp);
  imlib = Imlib_init(disp);
  fnlib = Fnlib_init(imlib);
  depth = imlib->x.depth;
  visual = imlib->x.visual;
  fg = XCreateGC(disp,root,0,&gcvals);
  bg = XCreateGC(disp,root,0,&gcvals);
  black = BlackPixel(disp, screen);
  XSetBackground(disp, fg, black);
  XSetForeground(disp, bg, black);
}
                                          
void LoadImage(char *file, ImageDat *image)
{
   ImlibImage *im;
   char path[256];
   char s1[512];
   getcwd(path, 256);
   if (file[0] != '\\') 
      sprintf(s1, "%s/%s", path, file);
   else
      sprintf(s1, "%s", file);
   if ((im = Imlib_load_image(imlib, s1)) == NULL) {
      fprintf(stderr,"Unable to load image %s.\n", s1);
      exit(-1);
   }
   Imlib_set_image_shape(imlib, im, &imask);
   Imlib_render(imlib, im, im->rgb_width, im->rgb_height);
   image->pixmap = Imlib_move_image(imlib, im);
   image->mask = Imlib_move_mask(imlib, im);
   image->w = im->rgb_width;
   image->h = im->rgb_height;
   image->name = malloc(sizeof(s1));
   strcpy(image->name, s1); 
   Imlib_destroy_image(imlib, im);
}

Window CreateWin(Window parent, int x, int y, int w, int h)
{
   XSetWindowAttributes xatrib;
   Window win;
   xatrib.override_redirect = TRUE;
   win = XCreateWindow(disp, parent, x, y, w, h, 0, depth, InputOutput, visual,
                       CWOverrideRedirect, &xatrib);
   XSelectInput(disp, win, KeyPressMask | ButtonPressMask | ButtonReleaseMask | EnterWindowMask | LeaveWindowMask | ButtonMotionMask | ExposureMask);
   return win;
}

void FreeImageDat(ImageDat *dat)
{
   if (!dat)
      return;
   free(dat->name);
   dat->name = NULL;
   Imlib_free_pixmap(imlib, dat->pixmap);
   Imlib_free_pixmap(imlib, dat->mask);
   dat->pixmap = 0;
   dat->mask = 0;
   free(dat);
   dat = NULL;
}
