#include "../emusic.h"

void CreateStatusWin(StatusWin *statuswin)
{
}

void DefaultsStatusWin(StatusWin *statuswin)
{
   statuswin->mono = NULL;
   statuswin->stereo = NULL;
   statuswin->play = NULL;
   statuswin->pause = NULL;
   statuswin->stop = NULL;
   statuswin->bitrate = NULL;
   statuswin->samplerate = NULL;
}

void ConfigStatusWin(StatusWin *statuswin, Window parent, FILE *in)
{
   char st[256];
   char s1[128], s2[128];
   int end = FALSE;
   DefaultsStatusWin(statuswin);
   while (!end) {
      if (!fgets(st, 256, in)) {
          fprintf(stderr,"Unexpected EOF in config file\n");
          exit(-1);
      }
      if ((st[0] != '#') && (st[0] != '\n') && (st[0] != '\0')) {
         splitstring(s1, s2, st);
         if (!strncmp("END", s1, 3))
            end = TRUE;
         else if (!strncmp("BEGIN", s1, 5)) {
            upstr(s2);
            if (!strncmp("STEREO", s2, 6)) {
               statuswin->stereo = malloc(sizeof(Button));
               ConfigButton(statuswin->stereo, parent, in);
            }
            else if (!strncmp("MONO", s2, 4)) {
               statuswin->mono = malloc(sizeof(Button));
               ConfigButton(statuswin->mono, parent, in);
            }
            else if (!strncmp("PLAY", s2, 4)) {
               statuswin->play = malloc(sizeof(Button));
               ConfigButton(statuswin->play, parent, in);
            }
            else if (!strncmp("PAUSE", s2, 5)) {
               statuswin->pause = malloc(sizeof(Button));
               ConfigButton(statuswin->pause, parent, in);
            }
            else if (!strncmp("STOP", s2, 4)) {
               statuswin->stop = malloc(sizeof(Button));
               ConfigButton(statuswin->stop, parent, in);
            }
            else if (!strncmp("BITRATE", s2, 7)) {
               statuswin->bitrate = malloc(sizeof(TextBox));
               ConfigTextBox(statuswin->bitrate, parent, in);
               SetTextTextBox(statuswin->bitrate, "   ");
            }
            else if (!strncmp("SAMPLERATE", s2, 10)) {
               statuswin->samplerate = malloc(sizeof(TextBox));
               ConfigTextBox(statuswin->samplerate, parent, in);
               SetTextTextBox(statuswin->samplerate, "   ");
            }
         }
      }
   }
   CreateStatusWin(statuswin);
}

void UpdateStatusWin(StatusWin *statuswin)
{
   static int ostereo = 0, omono = 0, obit = -1; 
   static int osample = -1, opause = -1, oplay = -1, ostop = -1; 
   int stereo = 0, mono = 0, bit = 0, sample = 0, pause = 0;
   int play = 0, stop = 0;
   char temp[4];
   if (!statuswin)
      return;
   GetAudioStats(&stereo, &mono, &bit, &sample);
   if (playing && !paused)
      play = TRUE;
   else if (paused)
      pause = TRUE;
   else
      stop = TRUE;
   if (statuswin->mono && (mono != omono)) {
      omono = mono;
      if (mono)
         ClickButton(statuswin->mono);
      else
         NormalButton(statuswin->mono);
   }
   if (statuswin->stereo && (stereo != ostereo)) {
      ostereo = stereo;
      if (stereo)
         ClickButton(statuswin->stereo);
      else
         NormalButton(statuswin->stereo);
   }
   if (statuswin->play && (play != oplay)) {
      oplay = play;
      if (play)
         UnhideButton(statuswin->play);
      else
         HideButton(statuswin->play);
   }
   if (statuswin->pause && (pause != opause)) {
      opause = pause;
      if (pause)
         UnhideButton(statuswin->pause);
      else
         HideButton(statuswin->pause);
   }
   if (statuswin->stop && (stop != ostop)) {
      ostop = stop;
      if (stop)
         UnhideButton(statuswin->stop);
      else
         HideButton(statuswin->stop);
   }
   if (statuswin->bitrate && (bit != obit)) {
      obit = bit;
      if (bit)
         sprintf(temp, "%d", bit);
      else
         sprintf(temp, "   ");
      SetTextTextBox(statuswin->bitrate,temp);
      UpdateTextBox(statuswin->bitrate);
   }
   if (statuswin->samplerate && (sample != osample)) {
      osample = sample;
      if (sample)
         sprintf(temp, "%d", sample);
      else
         sprintf(temp, "   ");
      SetTextTextBox(statuswin->samplerate, temp);
      UpdateTextBox(statuswin->samplerate);
   }
}

void FreeStatusWin(StatusWin *status)
{
   if (!status)
      return;
   FreeButton(status->mono);
   FreeButton(status->stereo);
   FreeButton(status->play);
   FreeButton(status->pause);
   FreeButton(status->stop);
   FreeTextBox(status->bitrate);
   FreeTextBox(status->samplerate);
   free(status);
   status = NULL;
}
