#include "imagedat.h"
#include "actions.h"
#include "button.h"
#include "slider.h"
#include "textbox.h"  
#include "listbox.h"
#include "back.h"
#include "container.h"
#include "filebox.h"
#include "status.h"

#define BUTTON      1
#define MULTIBUTTON 2
#define SLIDER      3
#define TEXTBOX     4
#define LISTBOX     5
#define BACKGROUND  6
#define CONTAINER   7
#define FILEBOX     8
#define WIDGET      9

extern int deferred;

struct _widget {
   void *widget;
   int type;
   struct _widget *next;
};

typedef struct {
   Window win;
   int exposed;
   struct _widget *first;
   struct _widget *last;
   int raised;
   int state;
   int visible;
   int deferred;
   int offset_x, offset_y;
   int x, y;
   int shaped;
} Widget;

void RaiseLowerWidget(Widget *widget);
int FindEventWidget(Widget *widget, XEvent ev);
void MoveWidget(Widget *widget, Widget *offset, int x, int y);
void UnhideWidget(Widget *widget);
void HideWidget(Widget *widget);
void CreateWidget(Widget *widget);
void FreeWidget(Widget *widget);
