#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include "../common.h"
#include "cd.h"
#include "struct.h"

#define DEFAULTDEVICE "/dev/cdrom"

char cdplayerDevice[128]=DEFAULTDEVICE;

int currenttrack=0;
int maxtracks=31;

extern int cd_status();
extern void play_cd();
extern void stop_cd();
extern void eject_cd();
extern void pause_cd();

extern int cur_track, cur_index, cur_lasttrack, cur_firsttrack, cur_pos_abs ;
extern int cur_frame, cur_pos_rel, cur_tracklen, cur_cdlen, cur_ntracks ;
extern int cur_nsections, cur_listno, cur_stopmode, exit_on_eject, cur_balance ;
extern enum cd_modes cur_cdmode;
extern char cur_contd, cur_avoid;
extern char *cd_device;
extern struct cdinfo_wm thiscd, *cd;

int cur_balance = 10;
int info_modified = 0;

/* (denis) my globals : */


unsigned int cue_time = 10;     /* nbr of seconds for cue -> see -c command line option */
unsigned int vol_step = 5;      /* Volume to set when right click on display */
unsigned int autoPlay = 0;      /* if set, play a disk when it is inserted -> see -a c.l. option  */
unsigned int datatrack = 0;     /* is the current track a data track ? */

unsigned int curr_track = 0;

void pre_cda(void)
{
   cd_status();
   if (cur_cdmode != EJECTED) {
	if (cd->trk[curr_track].data) datatrack = 1;
	else datatrack = 0;
   }
   cd_status();
}

void seek_to_frame(int second)
{
   pre_cda();
   maxtracks = thiscd.ntracks + 1;
   play_cd(curr_track, second, maxtracks);
   cd_status();
}

int getnumtracks(void)
{
   cd_status();
   return thiscd.ntracks;
}

int play(int start, int track)
{
   int maxtracks;
   curr_track = track;
   pre_cda();
   maxtracks = thiscd.ntracks + 1;
   play_cd(curr_track, start, maxtracks);
   cd_status();
   pthread_create(&player_thread, NULL, (void *)cd_thread, NULL);
   return 1;
}

void pause_it(void)
{
   pre_cda();
   pause_cd();
}

void stop(int playing)
{
   pthread_cancel(player_thread);
   usleep(100);
   pre_cda();
   if (playing) {
      curr_track = 0;
      cur_cdmode = 3;
      stop_cd();
   }
   else {
      curr_track = 0;
      eject_cd();
   }
}

int get_second(void) 
{
   if (!cd_status())
      return 0;
   else return cur_pos_rel;
}

int get_length(int track)
{
   if (!cd_status())
      return 0; 
   return cd->trk[track-1].length;
}

void cd_thread(void)
{
   pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
   pthread_setcanceltype(PTHREAD_CANCEL_DEFERRED, NULL);
   while (curr_track != cur_track) {
      cd_status();
      usleep(50);
   }
   while (1) {
      pthread_mutex_lock(&player_lock);
      cd_status();
      if (curr_track != cur_track) {
         end_song = 1;
      }
      pthread_mutex_unlock(&player_lock);
      pthread_testcancel();
      usleep(50);
   }
}

void set_name(struct playlist_item *song)
{
    sprintf(song->name,"CD Track %d", atoi(song->path+1));
}

int is_file(char *path)
{
   char *temp;
   if ((temp = strrchr(path, '.')))
      if (!strcasecmp((temp+1),"cda"))
         return 1;
   return 0;
} 

void version_info(char *id, char *version, char *copyright)
{
   strcpy(id, "ascd");
   strcpy(version, "0.7");
   strcpy(copyright, "1997 Rob Malda and Denis Bourez");
}

void init(void)
{
}

void get_info(struct playlist_item *song)
{
}

void config(char *left, char *right)
{
}
