#ifndef _CD_H
#define _CD_H

#include <string.h>
#include <X11/Xthreads.h>

#define PLAY 0
#define PAUSE 1
#define STOP 2
#define UPTRACK 3
#define DNTRACK 4
#define CUE 5
#define REV 6
#define FIRST 7
#define LAST 8
#define LOOP 9
#define DIRECTACCESS 10
#define INTROSCAN 11
#define INTRONEXT 12
#define LOCACCESS 13
#define NOTHING 14
      
void seek_to_frame(int second);
int play(int start, int track);
void pause_it(void);
void stop(int playing);
int frame_to_sec(int frame);
int get_length(int track);
void cd_thread(void);
int getnumtracks(void);
int get_second(void);
void set_name(struct playlist_item *song);
int is_file(char *path);
void version_info(char *id, char *version, char *copyright);
void init(void);
void get_info(struct playlist_item *song);
void config(char *left, char *right);

extern int dumbcdmode;
extern void handle_end(void);

extern int end_song;
extern pthread_t player_thread;
extern pthread_mutex_t player_lock;
#endif
