#ifndef PLAYLIST_H
#define PLAYLIST_H

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

typedef struct {
   char song[31];
   char artist[31];
   char album[31];
   char year[5];
   char comment[31];
   int genre;
} ID3Tag;

struct playlist_item {
  char name[256];
  char path[256];
  int length;
  int pos;
  ID3Tag tag;
  int type;
  struct playlist_item *next;
  struct playlist_item *prev;
};

typedef struct {
  struct playlist_item *first;
  struct playlist_item *last;
  int length;
} PlayList;                          

#ifdef __cplusplus
extern "C" {
#endif
	
extern int setup_audio();
extern void set_bitrate();
extern void close_audio();
extern void audioBufferFlush();
extern void audioFlush();
extern int end_of_song;
extern int parsebool();
extern int audio_play();

#ifdef __cplusplus
}
#endif

#endif
